# Intrinio API
#
# Welcome to the Intrinio API! Through our Financial Data Marketplace, we offer a wide selection of financial data feed APIs sourced by our own proprietary processes as well as from many data vendors. For a complete API request / response reference please view the [Intrinio API documentation](https://docs.intrinio.com/documentation/api_v2). If you need additional help in using the API, please visit the [Intrinio website](https://intrinio.com) and click on the chat icon in the lower right corner.
#
# OpenAPI spec version: 2.30.0
# 
# Generated by: https://github.com/swagger-api/swagger-codegen.git


#' ESGComprehensiveRatingWithCompany Class
#'
#' @field date 
#' @field country_average_rating 
#' @field industry_average_rating 
#' @field overall_rating 
#' @field community_rating 
#' @field employee_rating 
#' @field environment_rating 
#' @field governance_rating 
#' @field human_rights_and_supply_chain_rating 
#' @field community_dev_and_philanthropy_rating 
#' @field product_rating 
#' @field compensation_and_benefits_rating 
#' @field diversity_and_labor_rights_rating 
#' @field training_health_and_safety_rating 
#' @field energy_climate_change_rating 
#' @field environment_policy_and_reporting_rating 
#' @field resource_management_rating 
#' @field board_rating 
#' @field leadership_ethics_rating 
#' @field transparency_reporting_rating 
#' @field country_percentile_rank 
#' @field industry_percentile_rank 
#' @field overall_percentile_rank 
#' @field community_percentile_rank 
#' @field employee_percentile_rank 
#' @field environment_percentile_rank 
#' @field governance_percentile_rank 
#' @field human_rights_and_supply_chain_percentile_rank 
#' @field community_dev_and_philanthropy_percentile_rank 
#' @field product_percentile_rank 
#' @field compensation_and_benefits_percentile_rank 
#' @field diversity_and_labor_rights_percentile_rank 
#' @field training_health_and_safety_percentile_rank 
#' @field energy_climate_change_percentile_rank 
#' @field environment_policy_and_reporting_percentile_rank 
#' @field resource_management_percentile_rank 
#' @field board_percentile_rank 
#' @field leadership_ethics_percentile_rank 
#' @field transparency_reporting_percentile_rank 
#' @field company 
#'
#' @importFrom R6 R6Class
#' @importFrom jsonlite fromJSON toJSON
#' @export
ESGComprehensiveRatingWithCompany <- R6::R6Class(
  'ESGComprehensiveRatingWithCompany',
  public = list(
    `date` = NA,
    `country_average_rating` = NA,
    `industry_average_rating` = NA,
    `overall_rating` = NA,
    `community_rating` = NA,
    `employee_rating` = NA,
    `environment_rating` = NA,
    `governance_rating` = NA,
    `human_rights_and_supply_chain_rating` = NA,
    `community_dev_and_philanthropy_rating` = NA,
    `product_rating` = NA,
    `compensation_and_benefits_rating` = NA,
    `diversity_and_labor_rights_rating` = NA,
    `training_health_and_safety_rating` = NA,
    `energy_climate_change_rating` = NA,
    `environment_policy_and_reporting_rating` = NA,
    `resource_management_rating` = NA,
    `board_rating` = NA,
    `leadership_ethics_rating` = NA,
    `transparency_reporting_rating` = NA,
    `country_percentile_rank` = NA,
    `industry_percentile_rank` = NA,
    `overall_percentile_rank` = NA,
    `community_percentile_rank` = NA,
    `employee_percentile_rank` = NA,
    `environment_percentile_rank` = NA,
    `governance_percentile_rank` = NA,
    `human_rights_and_supply_chain_percentile_rank` = NA,
    `community_dev_and_philanthropy_percentile_rank` = NA,
    `product_percentile_rank` = NA,
    `compensation_and_benefits_percentile_rank` = NA,
    `diversity_and_labor_rights_percentile_rank` = NA,
    `training_health_and_safety_percentile_rank` = NA,
    `energy_climate_change_percentile_rank` = NA,
    `environment_policy_and_reporting_percentile_rank` = NA,
    `resource_management_percentile_rank` = NA,
    `board_percentile_rank` = NA,
    `leadership_ethics_percentile_rank` = NA,
    `transparency_reporting_percentile_rank` = NA,
    `company` = NA,
    initialize = function(`date`, `country_average_rating`, `industry_average_rating`, `overall_rating`, `community_rating`, `employee_rating`, `environment_rating`, `governance_rating`, `human_rights_and_supply_chain_rating`, `community_dev_and_philanthropy_rating`, `product_rating`, `compensation_and_benefits_rating`, `diversity_and_labor_rights_rating`, `training_health_and_safety_rating`, `energy_climate_change_rating`, `environment_policy_and_reporting_rating`, `resource_management_rating`, `board_rating`, `leadership_ethics_rating`, `transparency_reporting_rating`, `country_percentile_rank`, `industry_percentile_rank`, `overall_percentile_rank`, `community_percentile_rank`, `employee_percentile_rank`, `environment_percentile_rank`, `governance_percentile_rank`, `human_rights_and_supply_chain_percentile_rank`, `community_dev_and_philanthropy_percentile_rank`, `product_percentile_rank`, `compensation_and_benefits_percentile_rank`, `diversity_and_labor_rights_percentile_rank`, `training_health_and_safety_percentile_rank`, `energy_climate_change_percentile_rank`, `environment_policy_and_reporting_percentile_rank`, `resource_management_percentile_rank`, `board_percentile_rank`, `leadership_ethics_percentile_rank`, `transparency_reporting_percentile_rank`, `company`){
      if (!missing(`date`)) {
        self$`date` <- `date`
      }
      if (!missing(`country_average_rating`)) {
        self$`country_average_rating` <- `country_average_rating`
      }
      if (!missing(`industry_average_rating`)) {
        self$`industry_average_rating` <- `industry_average_rating`
      }
      if (!missing(`overall_rating`)) {
        self$`overall_rating` <- `overall_rating`
      }
      if (!missing(`community_rating`)) {
        self$`community_rating` <- `community_rating`
      }
      if (!missing(`employee_rating`)) {
        self$`employee_rating` <- `employee_rating`
      }
      if (!missing(`environment_rating`)) {
        self$`environment_rating` <- `environment_rating`
      }
      if (!missing(`governance_rating`)) {
        self$`governance_rating` <- `governance_rating`
      }
      if (!missing(`human_rights_and_supply_chain_rating`)) {
        self$`human_rights_and_supply_chain_rating` <- `human_rights_and_supply_chain_rating`
      }
      if (!missing(`community_dev_and_philanthropy_rating`)) {
        self$`community_dev_and_philanthropy_rating` <- `community_dev_and_philanthropy_rating`
      }
      if (!missing(`product_rating`)) {
        self$`product_rating` <- `product_rating`
      }
      if (!missing(`compensation_and_benefits_rating`)) {
        self$`compensation_and_benefits_rating` <- `compensation_and_benefits_rating`
      }
      if (!missing(`diversity_and_labor_rights_rating`)) {
        self$`diversity_and_labor_rights_rating` <- `diversity_and_labor_rights_rating`
      }
      if (!missing(`training_health_and_safety_rating`)) {
        self$`training_health_and_safety_rating` <- `training_health_and_safety_rating`
      }
      if (!missing(`energy_climate_change_rating`)) {
        self$`energy_climate_change_rating` <- `energy_climate_change_rating`
      }
      if (!missing(`environment_policy_and_reporting_rating`)) {
        self$`environment_policy_and_reporting_rating` <- `environment_policy_and_reporting_rating`
      }
      if (!missing(`resource_management_rating`)) {
        self$`resource_management_rating` <- `resource_management_rating`
      }
      if (!missing(`board_rating`)) {
        self$`board_rating` <- `board_rating`
      }
      if (!missing(`leadership_ethics_rating`)) {
        self$`leadership_ethics_rating` <- `leadership_ethics_rating`
      }
      if (!missing(`transparency_reporting_rating`)) {
        self$`transparency_reporting_rating` <- `transparency_reporting_rating`
      }
      if (!missing(`country_percentile_rank`)) {
        self$`country_percentile_rank` <- `country_percentile_rank`
      }
      if (!missing(`industry_percentile_rank`)) {
        self$`industry_percentile_rank` <- `industry_percentile_rank`
      }
      if (!missing(`overall_percentile_rank`)) {
        self$`overall_percentile_rank` <- `overall_percentile_rank`
      }
      if (!missing(`community_percentile_rank`)) {
        self$`community_percentile_rank` <- `community_percentile_rank`
      }
      if (!missing(`employee_percentile_rank`)) {
        self$`employee_percentile_rank` <- `employee_percentile_rank`
      }
      if (!missing(`environment_percentile_rank`)) {
        self$`environment_percentile_rank` <- `environment_percentile_rank`
      }
      if (!missing(`governance_percentile_rank`)) {
        self$`governance_percentile_rank` <- `governance_percentile_rank`
      }
      if (!missing(`human_rights_and_supply_chain_percentile_rank`)) {
        self$`human_rights_and_supply_chain_percentile_rank` <- `human_rights_and_supply_chain_percentile_rank`
      }
      if (!missing(`community_dev_and_philanthropy_percentile_rank`)) {
        self$`community_dev_and_philanthropy_percentile_rank` <- `community_dev_and_philanthropy_percentile_rank`
      }
      if (!missing(`product_percentile_rank`)) {
        self$`product_percentile_rank` <- `product_percentile_rank`
      }
      if (!missing(`compensation_and_benefits_percentile_rank`)) {
        self$`compensation_and_benefits_percentile_rank` <- `compensation_and_benefits_percentile_rank`
      }
      if (!missing(`diversity_and_labor_rights_percentile_rank`)) {
        self$`diversity_and_labor_rights_percentile_rank` <- `diversity_and_labor_rights_percentile_rank`
      }
      if (!missing(`training_health_and_safety_percentile_rank`)) {
        self$`training_health_and_safety_percentile_rank` <- `training_health_and_safety_percentile_rank`
      }
      if (!missing(`energy_climate_change_percentile_rank`)) {
        self$`energy_climate_change_percentile_rank` <- `energy_climate_change_percentile_rank`
      }
      if (!missing(`environment_policy_and_reporting_percentile_rank`)) {
        self$`environment_policy_and_reporting_percentile_rank` <- `environment_policy_and_reporting_percentile_rank`
      }
      if (!missing(`resource_management_percentile_rank`)) {
        self$`resource_management_percentile_rank` <- `resource_management_percentile_rank`
      }
      if (!missing(`board_percentile_rank`)) {
        self$`board_percentile_rank` <- `board_percentile_rank`
      }
      if (!missing(`leadership_ethics_percentile_rank`)) {
        self$`leadership_ethics_percentile_rank` <- `leadership_ethics_percentile_rank`
      }
      if (!missing(`transparency_reporting_percentile_rank`)) {
        self$`transparency_reporting_percentile_rank` <- `transparency_reporting_percentile_rank`
      }
      if (!missing(`company`)) {
        self$`company` <- `company`
      }
    },
    toJSON = function() {
      ESGComprehensiveRatingWithCompanyObject <- list()
      if (!is.null(self$`date`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`date`) && ((length(self$`date`) == 0) || ((length(self$`date`) != 0 && R6::is.R6(self$`date`[[1]]))))) {
          ESGComprehensiveRatingWithCompanyObject[['date']] <- lapply(self$`date`, function(x) x$toJSON())
        } else {
          ESGComprehensiveRatingWithCompanyObject[['date']] <- jsonlite::toJSON(self$`date`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`country_average_rating`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`country_average_rating`) && ((length(self$`country_average_rating`) == 0) || ((length(self$`country_average_rating`) != 0 && R6::is.R6(self$`country_average_rating`[[1]]))))) {
          ESGComprehensiveRatingWithCompanyObject[['country_average_rating']] <- lapply(self$`country_average_rating`, function(x) x$toJSON())
        } else {
          ESGComprehensiveRatingWithCompanyObject[['country_average_rating']] <- jsonlite::toJSON(self$`country_average_rating`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`industry_average_rating`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`industry_average_rating`) && ((length(self$`industry_average_rating`) == 0) || ((length(self$`industry_average_rating`) != 0 && R6::is.R6(self$`industry_average_rating`[[1]]))))) {
          ESGComprehensiveRatingWithCompanyObject[['industry_average_rating']] <- lapply(self$`industry_average_rating`, function(x) x$toJSON())
        } else {
          ESGComprehensiveRatingWithCompanyObject[['industry_average_rating']] <- jsonlite::toJSON(self$`industry_average_rating`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`overall_rating`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`overall_rating`) && ((length(self$`overall_rating`) == 0) || ((length(self$`overall_rating`) != 0 && R6::is.R6(self$`overall_rating`[[1]]))))) {
          ESGComprehensiveRatingWithCompanyObject[['overall_rating']] <- lapply(self$`overall_rating`, function(x) x$toJSON())
        } else {
          ESGComprehensiveRatingWithCompanyObject[['overall_rating']] <- jsonlite::toJSON(self$`overall_rating`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`community_rating`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`community_rating`) && ((length(self$`community_rating`) == 0) || ((length(self$`community_rating`) != 0 && R6::is.R6(self$`community_rating`[[1]]))))) {
          ESGComprehensiveRatingWithCompanyObject[['community_rating']] <- lapply(self$`community_rating`, function(x) x$toJSON())
        } else {
          ESGComprehensiveRatingWithCompanyObject[['community_rating']] <- jsonlite::toJSON(self$`community_rating`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`employee_rating`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`employee_rating`) && ((length(self$`employee_rating`) == 0) || ((length(self$`employee_rating`) != 0 && R6::is.R6(self$`employee_rating`[[1]]))))) {
          ESGComprehensiveRatingWithCompanyObject[['employee_rating']] <- lapply(self$`employee_rating`, function(x) x$toJSON())
        } else {
          ESGComprehensiveRatingWithCompanyObject[['employee_rating']] <- jsonlite::toJSON(self$`employee_rating`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`environment_rating`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`environment_rating`) && ((length(self$`environment_rating`) == 0) || ((length(self$`environment_rating`) != 0 && R6::is.R6(self$`environment_rating`[[1]]))))) {
          ESGComprehensiveRatingWithCompanyObject[['environment_rating']] <- lapply(self$`environment_rating`, function(x) x$toJSON())
        } else {
          ESGComprehensiveRatingWithCompanyObject[['environment_rating']] <- jsonlite::toJSON(self$`environment_rating`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`governance_rating`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`governance_rating`) && ((length(self$`governance_rating`) == 0) || ((length(self$`governance_rating`) != 0 && R6::is.R6(self$`governance_rating`[[1]]))))) {
          ESGComprehensiveRatingWithCompanyObject[['governance_rating']] <- lapply(self$`governance_rating`, function(x) x$toJSON())
        } else {
          ESGComprehensiveRatingWithCompanyObject[['governance_rating']] <- jsonlite::toJSON(self$`governance_rating`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`human_rights_and_supply_chain_rating`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`human_rights_and_supply_chain_rating`) && ((length(self$`human_rights_and_supply_chain_rating`) == 0) || ((length(self$`human_rights_and_supply_chain_rating`) != 0 && R6::is.R6(self$`human_rights_and_supply_chain_rating`[[1]]))))) {
          ESGComprehensiveRatingWithCompanyObject[['human_rights_and_supply_chain_rating']] <- lapply(self$`human_rights_and_supply_chain_rating`, function(x) x$toJSON())
        } else {
          ESGComprehensiveRatingWithCompanyObject[['human_rights_and_supply_chain_rating']] <- jsonlite::toJSON(self$`human_rights_and_supply_chain_rating`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`community_dev_and_philanthropy_rating`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`community_dev_and_philanthropy_rating`) && ((length(self$`community_dev_and_philanthropy_rating`) == 0) || ((length(self$`community_dev_and_philanthropy_rating`) != 0 && R6::is.R6(self$`community_dev_and_philanthropy_rating`[[1]]))))) {
          ESGComprehensiveRatingWithCompanyObject[['community_dev_and_philanthropy_rating']] <- lapply(self$`community_dev_and_philanthropy_rating`, function(x) x$toJSON())
        } else {
          ESGComprehensiveRatingWithCompanyObject[['community_dev_and_philanthropy_rating']] <- jsonlite::toJSON(self$`community_dev_and_philanthropy_rating`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`product_rating`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`product_rating`) && ((length(self$`product_rating`) == 0) || ((length(self$`product_rating`) != 0 && R6::is.R6(self$`product_rating`[[1]]))))) {
          ESGComprehensiveRatingWithCompanyObject[['product_rating']] <- lapply(self$`product_rating`, function(x) x$toJSON())
        } else {
          ESGComprehensiveRatingWithCompanyObject[['product_rating']] <- jsonlite::toJSON(self$`product_rating`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`compensation_and_benefits_rating`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`compensation_and_benefits_rating`) && ((length(self$`compensation_and_benefits_rating`) == 0) || ((length(self$`compensation_and_benefits_rating`) != 0 && R6::is.R6(self$`compensation_and_benefits_rating`[[1]]))))) {
          ESGComprehensiveRatingWithCompanyObject[['compensation_and_benefits_rating']] <- lapply(self$`compensation_and_benefits_rating`, function(x) x$toJSON())
        } else {
          ESGComprehensiveRatingWithCompanyObject[['compensation_and_benefits_rating']] <- jsonlite::toJSON(self$`compensation_and_benefits_rating`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`diversity_and_labor_rights_rating`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`diversity_and_labor_rights_rating`) && ((length(self$`diversity_and_labor_rights_rating`) == 0) || ((length(self$`diversity_and_labor_rights_rating`) != 0 && R6::is.R6(self$`diversity_and_labor_rights_rating`[[1]]))))) {
          ESGComprehensiveRatingWithCompanyObject[['diversity_and_labor_rights_rating']] <- lapply(self$`diversity_and_labor_rights_rating`, function(x) x$toJSON())
        } else {
          ESGComprehensiveRatingWithCompanyObject[['diversity_and_labor_rights_rating']] <- jsonlite::toJSON(self$`diversity_and_labor_rights_rating`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`training_health_and_safety_rating`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`training_health_and_safety_rating`) && ((length(self$`training_health_and_safety_rating`) == 0) || ((length(self$`training_health_and_safety_rating`) != 0 && R6::is.R6(self$`training_health_and_safety_rating`[[1]]))))) {
          ESGComprehensiveRatingWithCompanyObject[['training_health_and_safety_rating']] <- lapply(self$`training_health_and_safety_rating`, function(x) x$toJSON())
        } else {
          ESGComprehensiveRatingWithCompanyObject[['training_health_and_safety_rating']] <- jsonlite::toJSON(self$`training_health_and_safety_rating`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`energy_climate_change_rating`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`energy_climate_change_rating`) && ((length(self$`energy_climate_change_rating`) == 0) || ((length(self$`energy_climate_change_rating`) != 0 && R6::is.R6(self$`energy_climate_change_rating`[[1]]))))) {
          ESGComprehensiveRatingWithCompanyObject[['energy_climate_change_rating']] <- lapply(self$`energy_climate_change_rating`, function(x) x$toJSON())
        } else {
          ESGComprehensiveRatingWithCompanyObject[['energy_climate_change_rating']] <- jsonlite::toJSON(self$`energy_climate_change_rating`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`environment_policy_and_reporting_rating`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`environment_policy_and_reporting_rating`) && ((length(self$`environment_policy_and_reporting_rating`) == 0) || ((length(self$`environment_policy_and_reporting_rating`) != 0 && R6::is.R6(self$`environment_policy_and_reporting_rating`[[1]]))))) {
          ESGComprehensiveRatingWithCompanyObject[['environment_policy_and_reporting_rating']] <- lapply(self$`environment_policy_and_reporting_rating`, function(x) x$toJSON())
        } else {
          ESGComprehensiveRatingWithCompanyObject[['environment_policy_and_reporting_rating']] <- jsonlite::toJSON(self$`environment_policy_and_reporting_rating`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`resource_management_rating`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`resource_management_rating`) && ((length(self$`resource_management_rating`) == 0) || ((length(self$`resource_management_rating`) != 0 && R6::is.R6(self$`resource_management_rating`[[1]]))))) {
          ESGComprehensiveRatingWithCompanyObject[['resource_management_rating']] <- lapply(self$`resource_management_rating`, function(x) x$toJSON())
        } else {
          ESGComprehensiveRatingWithCompanyObject[['resource_management_rating']] <- jsonlite::toJSON(self$`resource_management_rating`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`board_rating`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`board_rating`) && ((length(self$`board_rating`) == 0) || ((length(self$`board_rating`) != 0 && R6::is.R6(self$`board_rating`[[1]]))))) {
          ESGComprehensiveRatingWithCompanyObject[['board_rating']] <- lapply(self$`board_rating`, function(x) x$toJSON())
        } else {
          ESGComprehensiveRatingWithCompanyObject[['board_rating']] <- jsonlite::toJSON(self$`board_rating`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`leadership_ethics_rating`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`leadership_ethics_rating`) && ((length(self$`leadership_ethics_rating`) == 0) || ((length(self$`leadership_ethics_rating`) != 0 && R6::is.R6(self$`leadership_ethics_rating`[[1]]))))) {
          ESGComprehensiveRatingWithCompanyObject[['leadership_ethics_rating']] <- lapply(self$`leadership_ethics_rating`, function(x) x$toJSON())
        } else {
          ESGComprehensiveRatingWithCompanyObject[['leadership_ethics_rating']] <- jsonlite::toJSON(self$`leadership_ethics_rating`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`transparency_reporting_rating`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`transparency_reporting_rating`) && ((length(self$`transparency_reporting_rating`) == 0) || ((length(self$`transparency_reporting_rating`) != 0 && R6::is.R6(self$`transparency_reporting_rating`[[1]]))))) {
          ESGComprehensiveRatingWithCompanyObject[['transparency_reporting_rating']] <- lapply(self$`transparency_reporting_rating`, function(x) x$toJSON())
        } else {
          ESGComprehensiveRatingWithCompanyObject[['transparency_reporting_rating']] <- jsonlite::toJSON(self$`transparency_reporting_rating`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`country_percentile_rank`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`country_percentile_rank`) && ((length(self$`country_percentile_rank`) == 0) || ((length(self$`country_percentile_rank`) != 0 && R6::is.R6(self$`country_percentile_rank`[[1]]))))) {
          ESGComprehensiveRatingWithCompanyObject[['country_percentile_rank']] <- lapply(self$`country_percentile_rank`, function(x) x$toJSON())
        } else {
          ESGComprehensiveRatingWithCompanyObject[['country_percentile_rank']] <- jsonlite::toJSON(self$`country_percentile_rank`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`industry_percentile_rank`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`industry_percentile_rank`) && ((length(self$`industry_percentile_rank`) == 0) || ((length(self$`industry_percentile_rank`) != 0 && R6::is.R6(self$`industry_percentile_rank`[[1]]))))) {
          ESGComprehensiveRatingWithCompanyObject[['industry_percentile_rank']] <- lapply(self$`industry_percentile_rank`, function(x) x$toJSON())
        } else {
          ESGComprehensiveRatingWithCompanyObject[['industry_percentile_rank']] <- jsonlite::toJSON(self$`industry_percentile_rank`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`overall_percentile_rank`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`overall_percentile_rank`) && ((length(self$`overall_percentile_rank`) == 0) || ((length(self$`overall_percentile_rank`) != 0 && R6::is.R6(self$`overall_percentile_rank`[[1]]))))) {
          ESGComprehensiveRatingWithCompanyObject[['overall_percentile_rank']] <- lapply(self$`overall_percentile_rank`, function(x) x$toJSON())
        } else {
          ESGComprehensiveRatingWithCompanyObject[['overall_percentile_rank']] <- jsonlite::toJSON(self$`overall_percentile_rank`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`community_percentile_rank`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`community_percentile_rank`) && ((length(self$`community_percentile_rank`) == 0) || ((length(self$`community_percentile_rank`) != 0 && R6::is.R6(self$`community_percentile_rank`[[1]]))))) {
          ESGComprehensiveRatingWithCompanyObject[['community_percentile_rank']] <- lapply(self$`community_percentile_rank`, function(x) x$toJSON())
        } else {
          ESGComprehensiveRatingWithCompanyObject[['community_percentile_rank']] <- jsonlite::toJSON(self$`community_percentile_rank`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`employee_percentile_rank`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`employee_percentile_rank`) && ((length(self$`employee_percentile_rank`) == 0) || ((length(self$`employee_percentile_rank`) != 0 && R6::is.R6(self$`employee_percentile_rank`[[1]]))))) {
          ESGComprehensiveRatingWithCompanyObject[['employee_percentile_rank']] <- lapply(self$`employee_percentile_rank`, function(x) x$toJSON())
        } else {
          ESGComprehensiveRatingWithCompanyObject[['employee_percentile_rank']] <- jsonlite::toJSON(self$`employee_percentile_rank`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`environment_percentile_rank`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`environment_percentile_rank`) && ((length(self$`environment_percentile_rank`) == 0) || ((length(self$`environment_percentile_rank`) != 0 && R6::is.R6(self$`environment_percentile_rank`[[1]]))))) {
          ESGComprehensiveRatingWithCompanyObject[['environment_percentile_rank']] <- lapply(self$`environment_percentile_rank`, function(x) x$toJSON())
        } else {
          ESGComprehensiveRatingWithCompanyObject[['environment_percentile_rank']] <- jsonlite::toJSON(self$`environment_percentile_rank`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`governance_percentile_rank`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`governance_percentile_rank`) && ((length(self$`governance_percentile_rank`) == 0) || ((length(self$`governance_percentile_rank`) != 0 && R6::is.R6(self$`governance_percentile_rank`[[1]]))))) {
          ESGComprehensiveRatingWithCompanyObject[['governance_percentile_rank']] <- lapply(self$`governance_percentile_rank`, function(x) x$toJSON())
        } else {
          ESGComprehensiveRatingWithCompanyObject[['governance_percentile_rank']] <- jsonlite::toJSON(self$`governance_percentile_rank`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`human_rights_and_supply_chain_percentile_rank`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`human_rights_and_supply_chain_percentile_rank`) && ((length(self$`human_rights_and_supply_chain_percentile_rank`) == 0) || ((length(self$`human_rights_and_supply_chain_percentile_rank`) != 0 && R6::is.R6(self$`human_rights_and_supply_chain_percentile_rank`[[1]]))))) {
          ESGComprehensiveRatingWithCompanyObject[['human_rights_and_supply_chain_percentile_rank']] <- lapply(self$`human_rights_and_supply_chain_percentile_rank`, function(x) x$toJSON())
        } else {
          ESGComprehensiveRatingWithCompanyObject[['human_rights_and_supply_chain_percentile_rank']] <- jsonlite::toJSON(self$`human_rights_and_supply_chain_percentile_rank`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`community_dev_and_philanthropy_percentile_rank`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`community_dev_and_philanthropy_percentile_rank`) && ((length(self$`community_dev_and_philanthropy_percentile_rank`) == 0) || ((length(self$`community_dev_and_philanthropy_percentile_rank`) != 0 && R6::is.R6(self$`community_dev_and_philanthropy_percentile_rank`[[1]]))))) {
          ESGComprehensiveRatingWithCompanyObject[['community_dev_and_philanthropy_percentile_rank']] <- lapply(self$`community_dev_and_philanthropy_percentile_rank`, function(x) x$toJSON())
        } else {
          ESGComprehensiveRatingWithCompanyObject[['community_dev_and_philanthropy_percentile_rank']] <- jsonlite::toJSON(self$`community_dev_and_philanthropy_percentile_rank`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`product_percentile_rank`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`product_percentile_rank`) && ((length(self$`product_percentile_rank`) == 0) || ((length(self$`product_percentile_rank`) != 0 && R6::is.R6(self$`product_percentile_rank`[[1]]))))) {
          ESGComprehensiveRatingWithCompanyObject[['product_percentile_rank']] <- lapply(self$`product_percentile_rank`, function(x) x$toJSON())
        } else {
          ESGComprehensiveRatingWithCompanyObject[['product_percentile_rank']] <- jsonlite::toJSON(self$`product_percentile_rank`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`compensation_and_benefits_percentile_rank`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`compensation_and_benefits_percentile_rank`) && ((length(self$`compensation_and_benefits_percentile_rank`) == 0) || ((length(self$`compensation_and_benefits_percentile_rank`) != 0 && R6::is.R6(self$`compensation_and_benefits_percentile_rank`[[1]]))))) {
          ESGComprehensiveRatingWithCompanyObject[['compensation_and_benefits_percentile_rank']] <- lapply(self$`compensation_and_benefits_percentile_rank`, function(x) x$toJSON())
        } else {
          ESGComprehensiveRatingWithCompanyObject[['compensation_and_benefits_percentile_rank']] <- jsonlite::toJSON(self$`compensation_and_benefits_percentile_rank`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`diversity_and_labor_rights_percentile_rank`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`diversity_and_labor_rights_percentile_rank`) && ((length(self$`diversity_and_labor_rights_percentile_rank`) == 0) || ((length(self$`diversity_and_labor_rights_percentile_rank`) != 0 && R6::is.R6(self$`diversity_and_labor_rights_percentile_rank`[[1]]))))) {
          ESGComprehensiveRatingWithCompanyObject[['diversity_and_labor_rights_percentile_rank']] <- lapply(self$`diversity_and_labor_rights_percentile_rank`, function(x) x$toJSON())
        } else {
          ESGComprehensiveRatingWithCompanyObject[['diversity_and_labor_rights_percentile_rank']] <- jsonlite::toJSON(self$`diversity_and_labor_rights_percentile_rank`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`training_health_and_safety_percentile_rank`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`training_health_and_safety_percentile_rank`) && ((length(self$`training_health_and_safety_percentile_rank`) == 0) || ((length(self$`training_health_and_safety_percentile_rank`) != 0 && R6::is.R6(self$`training_health_and_safety_percentile_rank`[[1]]))))) {
          ESGComprehensiveRatingWithCompanyObject[['training_health_and_safety_percentile_rank']] <- lapply(self$`training_health_and_safety_percentile_rank`, function(x) x$toJSON())
        } else {
          ESGComprehensiveRatingWithCompanyObject[['training_health_and_safety_percentile_rank']] <- jsonlite::toJSON(self$`training_health_and_safety_percentile_rank`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`energy_climate_change_percentile_rank`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`energy_climate_change_percentile_rank`) && ((length(self$`energy_climate_change_percentile_rank`) == 0) || ((length(self$`energy_climate_change_percentile_rank`) != 0 && R6::is.R6(self$`energy_climate_change_percentile_rank`[[1]]))))) {
          ESGComprehensiveRatingWithCompanyObject[['energy_climate_change_percentile_rank']] <- lapply(self$`energy_climate_change_percentile_rank`, function(x) x$toJSON())
        } else {
          ESGComprehensiveRatingWithCompanyObject[['energy_climate_change_percentile_rank']] <- jsonlite::toJSON(self$`energy_climate_change_percentile_rank`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`environment_policy_and_reporting_percentile_rank`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`environment_policy_and_reporting_percentile_rank`) && ((length(self$`environment_policy_and_reporting_percentile_rank`) == 0) || ((length(self$`environment_policy_and_reporting_percentile_rank`) != 0 && R6::is.R6(self$`environment_policy_and_reporting_percentile_rank`[[1]]))))) {
          ESGComprehensiveRatingWithCompanyObject[['environment_policy_and_reporting_percentile_rank']] <- lapply(self$`environment_policy_and_reporting_percentile_rank`, function(x) x$toJSON())
        } else {
          ESGComprehensiveRatingWithCompanyObject[['environment_policy_and_reporting_percentile_rank']] <- jsonlite::toJSON(self$`environment_policy_and_reporting_percentile_rank`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`resource_management_percentile_rank`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`resource_management_percentile_rank`) && ((length(self$`resource_management_percentile_rank`) == 0) || ((length(self$`resource_management_percentile_rank`) != 0 && R6::is.R6(self$`resource_management_percentile_rank`[[1]]))))) {
          ESGComprehensiveRatingWithCompanyObject[['resource_management_percentile_rank']] <- lapply(self$`resource_management_percentile_rank`, function(x) x$toJSON())
        } else {
          ESGComprehensiveRatingWithCompanyObject[['resource_management_percentile_rank']] <- jsonlite::toJSON(self$`resource_management_percentile_rank`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`board_percentile_rank`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`board_percentile_rank`) && ((length(self$`board_percentile_rank`) == 0) || ((length(self$`board_percentile_rank`) != 0 && R6::is.R6(self$`board_percentile_rank`[[1]]))))) {
          ESGComprehensiveRatingWithCompanyObject[['board_percentile_rank']] <- lapply(self$`board_percentile_rank`, function(x) x$toJSON())
        } else {
          ESGComprehensiveRatingWithCompanyObject[['board_percentile_rank']] <- jsonlite::toJSON(self$`board_percentile_rank`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`leadership_ethics_percentile_rank`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`leadership_ethics_percentile_rank`) && ((length(self$`leadership_ethics_percentile_rank`) == 0) || ((length(self$`leadership_ethics_percentile_rank`) != 0 && R6::is.R6(self$`leadership_ethics_percentile_rank`[[1]]))))) {
          ESGComprehensiveRatingWithCompanyObject[['leadership_ethics_percentile_rank']] <- lapply(self$`leadership_ethics_percentile_rank`, function(x) x$toJSON())
        } else {
          ESGComprehensiveRatingWithCompanyObject[['leadership_ethics_percentile_rank']] <- jsonlite::toJSON(self$`leadership_ethics_percentile_rank`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`transparency_reporting_percentile_rank`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`transparency_reporting_percentile_rank`) && ((length(self$`transparency_reporting_percentile_rank`) == 0) || ((length(self$`transparency_reporting_percentile_rank`) != 0 && R6::is.R6(self$`transparency_reporting_percentile_rank`[[1]]))))) {
          ESGComprehensiveRatingWithCompanyObject[['transparency_reporting_percentile_rank']] <- lapply(self$`transparency_reporting_percentile_rank`, function(x) x$toJSON())
        } else {
          ESGComprehensiveRatingWithCompanyObject[['transparency_reporting_percentile_rank']] <- jsonlite::toJSON(self$`transparency_reporting_percentile_rank`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`company`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`company`) && ((length(self$`company`) == 0) || ((length(self$`company`) != 0 && R6::is.R6(self$`company`[[1]]))))) {
          ESGComprehensiveRatingWithCompanyObject[['company']] <- lapply(self$`company`, function(x) x$toJSON())
        } else {
          ESGComprehensiveRatingWithCompanyObject[['company']] <- jsonlite::toJSON(self$`company`, auto_unbox = TRUE)
        }
      }

      ESGComprehensiveRatingWithCompanyObject
    },
    fromJSON = function(ESGComprehensiveRatingWithCompanyJson) {
      ESGComprehensiveRatingWithCompanyObject <- jsonlite::fromJSON(ESGComprehensiveRatingWithCompanyJson)
      if (!is.null(ESGComprehensiveRatingWithCompanyObject$`date`)) {
        self$`date` <- ESGComprehensiveRatingWithCompanyObject$`date`
      }
      if (!is.null(ESGComprehensiveRatingWithCompanyObject$`country_average_rating`)) {
        self$`country_average_rating` <- ESGComprehensiveRatingWithCompanyObject$`country_average_rating`
      }
      if (!is.null(ESGComprehensiveRatingWithCompanyObject$`industry_average_rating`)) {
        self$`industry_average_rating` <- ESGComprehensiveRatingWithCompanyObject$`industry_average_rating`
      }
      if (!is.null(ESGComprehensiveRatingWithCompanyObject$`overall_rating`)) {
        self$`overall_rating` <- ESGComprehensiveRatingWithCompanyObject$`overall_rating`
      }
      if (!is.null(ESGComprehensiveRatingWithCompanyObject$`community_rating`)) {
        self$`community_rating` <- ESGComprehensiveRatingWithCompanyObject$`community_rating`
      }
      if (!is.null(ESGComprehensiveRatingWithCompanyObject$`employee_rating`)) {
        self$`employee_rating` <- ESGComprehensiveRatingWithCompanyObject$`employee_rating`
      }
      if (!is.null(ESGComprehensiveRatingWithCompanyObject$`environment_rating`)) {
        self$`environment_rating` <- ESGComprehensiveRatingWithCompanyObject$`environment_rating`
      }
      if (!is.null(ESGComprehensiveRatingWithCompanyObject$`governance_rating`)) {
        self$`governance_rating` <- ESGComprehensiveRatingWithCompanyObject$`governance_rating`
      }
      if (!is.null(ESGComprehensiveRatingWithCompanyObject$`human_rights_and_supply_chain_rating`)) {
        self$`human_rights_and_supply_chain_rating` <- ESGComprehensiveRatingWithCompanyObject$`human_rights_and_supply_chain_rating`
      }
      if (!is.null(ESGComprehensiveRatingWithCompanyObject$`community_dev_and_philanthropy_rating`)) {
        self$`community_dev_and_philanthropy_rating` <- ESGComprehensiveRatingWithCompanyObject$`community_dev_and_philanthropy_rating`
      }
      if (!is.null(ESGComprehensiveRatingWithCompanyObject$`product_rating`)) {
        self$`product_rating` <- ESGComprehensiveRatingWithCompanyObject$`product_rating`
      }
      if (!is.null(ESGComprehensiveRatingWithCompanyObject$`compensation_and_benefits_rating`)) {
        self$`compensation_and_benefits_rating` <- ESGComprehensiveRatingWithCompanyObject$`compensation_and_benefits_rating`
      }
      if (!is.null(ESGComprehensiveRatingWithCompanyObject$`diversity_and_labor_rights_rating`)) {
        self$`diversity_and_labor_rights_rating` <- ESGComprehensiveRatingWithCompanyObject$`diversity_and_labor_rights_rating`
      }
      if (!is.null(ESGComprehensiveRatingWithCompanyObject$`training_health_and_safety_rating`)) {
        self$`training_health_and_safety_rating` <- ESGComprehensiveRatingWithCompanyObject$`training_health_and_safety_rating`
      }
      if (!is.null(ESGComprehensiveRatingWithCompanyObject$`energy_climate_change_rating`)) {
        self$`energy_climate_change_rating` <- ESGComprehensiveRatingWithCompanyObject$`energy_climate_change_rating`
      }
      if (!is.null(ESGComprehensiveRatingWithCompanyObject$`environment_policy_and_reporting_rating`)) {
        self$`environment_policy_and_reporting_rating` <- ESGComprehensiveRatingWithCompanyObject$`environment_policy_and_reporting_rating`
      }
      if (!is.null(ESGComprehensiveRatingWithCompanyObject$`resource_management_rating`)) {
        self$`resource_management_rating` <- ESGComprehensiveRatingWithCompanyObject$`resource_management_rating`
      }
      if (!is.null(ESGComprehensiveRatingWithCompanyObject$`board_rating`)) {
        self$`board_rating` <- ESGComprehensiveRatingWithCompanyObject$`board_rating`
      }
      if (!is.null(ESGComprehensiveRatingWithCompanyObject$`leadership_ethics_rating`)) {
        self$`leadership_ethics_rating` <- ESGComprehensiveRatingWithCompanyObject$`leadership_ethics_rating`
      }
      if (!is.null(ESGComprehensiveRatingWithCompanyObject$`transparency_reporting_rating`)) {
        self$`transparency_reporting_rating` <- ESGComprehensiveRatingWithCompanyObject$`transparency_reporting_rating`
      }
      if (!is.null(ESGComprehensiveRatingWithCompanyObject$`country_percentile_rank`)) {
        self$`country_percentile_rank` <- ESGComprehensiveRatingWithCompanyObject$`country_percentile_rank`
      }
      if (!is.null(ESGComprehensiveRatingWithCompanyObject$`industry_percentile_rank`)) {
        self$`industry_percentile_rank` <- ESGComprehensiveRatingWithCompanyObject$`industry_percentile_rank`
      }
      if (!is.null(ESGComprehensiveRatingWithCompanyObject$`overall_percentile_rank`)) {
        self$`overall_percentile_rank` <- ESGComprehensiveRatingWithCompanyObject$`overall_percentile_rank`
      }
      if (!is.null(ESGComprehensiveRatingWithCompanyObject$`community_percentile_rank`)) {
        self$`community_percentile_rank` <- ESGComprehensiveRatingWithCompanyObject$`community_percentile_rank`
      }
      if (!is.null(ESGComprehensiveRatingWithCompanyObject$`employee_percentile_rank`)) {
        self$`employee_percentile_rank` <- ESGComprehensiveRatingWithCompanyObject$`employee_percentile_rank`
      }
      if (!is.null(ESGComprehensiveRatingWithCompanyObject$`environment_percentile_rank`)) {
        self$`environment_percentile_rank` <- ESGComprehensiveRatingWithCompanyObject$`environment_percentile_rank`
      }
      if (!is.null(ESGComprehensiveRatingWithCompanyObject$`governance_percentile_rank`)) {
        self$`governance_percentile_rank` <- ESGComprehensiveRatingWithCompanyObject$`governance_percentile_rank`
      }
      if (!is.null(ESGComprehensiveRatingWithCompanyObject$`human_rights_and_supply_chain_percentile_rank`)) {
        self$`human_rights_and_supply_chain_percentile_rank` <- ESGComprehensiveRatingWithCompanyObject$`human_rights_and_supply_chain_percentile_rank`
      }
      if (!is.null(ESGComprehensiveRatingWithCompanyObject$`community_dev_and_philanthropy_percentile_rank`)) {
        self$`community_dev_and_philanthropy_percentile_rank` <- ESGComprehensiveRatingWithCompanyObject$`community_dev_and_philanthropy_percentile_rank`
      }
      if (!is.null(ESGComprehensiveRatingWithCompanyObject$`product_percentile_rank`)) {
        self$`product_percentile_rank` <- ESGComprehensiveRatingWithCompanyObject$`product_percentile_rank`
      }
      if (!is.null(ESGComprehensiveRatingWithCompanyObject$`compensation_and_benefits_percentile_rank`)) {
        self$`compensation_and_benefits_percentile_rank` <- ESGComprehensiveRatingWithCompanyObject$`compensation_and_benefits_percentile_rank`
      }
      if (!is.null(ESGComprehensiveRatingWithCompanyObject$`diversity_and_labor_rights_percentile_rank`)) {
        self$`diversity_and_labor_rights_percentile_rank` <- ESGComprehensiveRatingWithCompanyObject$`diversity_and_labor_rights_percentile_rank`
      }
      if (!is.null(ESGComprehensiveRatingWithCompanyObject$`training_health_and_safety_percentile_rank`)) {
        self$`training_health_and_safety_percentile_rank` <- ESGComprehensiveRatingWithCompanyObject$`training_health_and_safety_percentile_rank`
      }
      if (!is.null(ESGComprehensiveRatingWithCompanyObject$`energy_climate_change_percentile_rank`)) {
        self$`energy_climate_change_percentile_rank` <- ESGComprehensiveRatingWithCompanyObject$`energy_climate_change_percentile_rank`
      }
      if (!is.null(ESGComprehensiveRatingWithCompanyObject$`environment_policy_and_reporting_percentile_rank`)) {
        self$`environment_policy_and_reporting_percentile_rank` <- ESGComprehensiveRatingWithCompanyObject$`environment_policy_and_reporting_percentile_rank`
      }
      if (!is.null(ESGComprehensiveRatingWithCompanyObject$`resource_management_percentile_rank`)) {
        self$`resource_management_percentile_rank` <- ESGComprehensiveRatingWithCompanyObject$`resource_management_percentile_rank`
      }
      if (!is.null(ESGComprehensiveRatingWithCompanyObject$`board_percentile_rank`)) {
        self$`board_percentile_rank` <- ESGComprehensiveRatingWithCompanyObject$`board_percentile_rank`
      }
      if (!is.null(ESGComprehensiveRatingWithCompanyObject$`leadership_ethics_percentile_rank`)) {
        self$`leadership_ethics_percentile_rank` <- ESGComprehensiveRatingWithCompanyObject$`leadership_ethics_percentile_rank`
      }
      if (!is.null(ESGComprehensiveRatingWithCompanyObject$`transparency_reporting_percentile_rank`)) {
        self$`transparency_reporting_percentile_rank` <- ESGComprehensiveRatingWithCompanyObject$`transparency_reporting_percentile_rank`
      }
      if (!is.null(ESGComprehensiveRatingWithCompanyObject$`company`)) {
        self$`company` <- ESGComprehensiveRatingWithCompanyObject$`company`
      }
    },
    toJSONString = function() {
      jsonlite::toJSON(self$toJSON(), auto_unbox = TRUE, pretty = TRUE)
    },
    fromJSONString = function(ESGComprehensiveRatingWithCompanyJson) {
      ESGComprehensiveRatingWithCompanyObject <- jsonlite::fromJSON(ESGComprehensiveRatingWithCompanyJson, simplifyDataFrame = FALSE)
      self$setFromList(ESGComprehensiveRatingWithCompanyObject)
    },
    setFromList = function(listObject) {



      if (!is.null(listObject$`date`)) {
        self$`date` <- self$`date` <- as.Date(listObject$`date`, "%Y-%m-%d")
      }
      else {
        self$`date` <- NA 
      }





      if (!is.null(listObject$`country_average_rating`)) {
        self$`country_average_rating` <- listObject$`country_average_rating`
      }
      else {
        self$`country_average_rating` <- NA 
      }

      if (!is.null(listObject$`industry_average_rating`)) {
        self$`industry_average_rating` <- listObject$`industry_average_rating`
      }
      else {
        self$`industry_average_rating` <- NA 
      }

      if (!is.null(listObject$`overall_rating`)) {
        self$`overall_rating` <- listObject$`overall_rating`
      }
      else {
        self$`overall_rating` <- NA 
      }

      if (!is.null(listObject$`community_rating`)) {
        self$`community_rating` <- listObject$`community_rating`
      }
      else {
        self$`community_rating` <- NA 
      }

      if (!is.null(listObject$`employee_rating`)) {
        self$`employee_rating` <- listObject$`employee_rating`
      }
      else {
        self$`employee_rating` <- NA 
      }

      if (!is.null(listObject$`environment_rating`)) {
        self$`environment_rating` <- listObject$`environment_rating`
      }
      else {
        self$`environment_rating` <- NA 
      }

      if (!is.null(listObject$`governance_rating`)) {
        self$`governance_rating` <- listObject$`governance_rating`
      }
      else {
        self$`governance_rating` <- NA 
      }

      if (!is.null(listObject$`human_rights_and_supply_chain_rating`)) {
        self$`human_rights_and_supply_chain_rating` <- listObject$`human_rights_and_supply_chain_rating`
      }
      else {
        self$`human_rights_and_supply_chain_rating` <- NA 
      }

      if (!is.null(listObject$`community_dev_and_philanthropy_rating`)) {
        self$`community_dev_and_philanthropy_rating` <- listObject$`community_dev_and_philanthropy_rating`
      }
      else {
        self$`community_dev_and_philanthropy_rating` <- NA 
      }

      if (!is.null(listObject$`product_rating`)) {
        self$`product_rating` <- listObject$`product_rating`
      }
      else {
        self$`product_rating` <- NA 
      }

      if (!is.null(listObject$`compensation_and_benefits_rating`)) {
        self$`compensation_and_benefits_rating` <- listObject$`compensation_and_benefits_rating`
      }
      else {
        self$`compensation_and_benefits_rating` <- NA 
      }

      if (!is.null(listObject$`diversity_and_labor_rights_rating`)) {
        self$`diversity_and_labor_rights_rating` <- listObject$`diversity_and_labor_rights_rating`
      }
      else {
        self$`diversity_and_labor_rights_rating` <- NA 
      }

      if (!is.null(listObject$`training_health_and_safety_rating`)) {
        self$`training_health_and_safety_rating` <- listObject$`training_health_and_safety_rating`
      }
      else {
        self$`training_health_and_safety_rating` <- NA 
      }

      if (!is.null(listObject$`energy_climate_change_rating`)) {
        self$`energy_climate_change_rating` <- listObject$`energy_climate_change_rating`
      }
      else {
        self$`energy_climate_change_rating` <- NA 
      }

      if (!is.null(listObject$`environment_policy_and_reporting_rating`)) {
        self$`environment_policy_and_reporting_rating` <- listObject$`environment_policy_and_reporting_rating`
      }
      else {
        self$`environment_policy_and_reporting_rating` <- NA 
      }

      if (!is.null(listObject$`resource_management_rating`)) {
        self$`resource_management_rating` <- listObject$`resource_management_rating`
      }
      else {
        self$`resource_management_rating` <- NA 
      }

      if (!is.null(listObject$`board_rating`)) {
        self$`board_rating` <- listObject$`board_rating`
      }
      else {
        self$`board_rating` <- NA 
      }

      if (!is.null(listObject$`leadership_ethics_rating`)) {
        self$`leadership_ethics_rating` <- listObject$`leadership_ethics_rating`
      }
      else {
        self$`leadership_ethics_rating` <- NA 
      }

      if (!is.null(listObject$`transparency_reporting_rating`)) {
        self$`transparency_reporting_rating` <- listObject$`transparency_reporting_rating`
      }
      else {
        self$`transparency_reporting_rating` <- NA 
      }

      if (!is.null(listObject$`country_percentile_rank`)) {
        self$`country_percentile_rank` <- listObject$`country_percentile_rank`
      }
      else {
        self$`country_percentile_rank` <- NA 
      }

      if (!is.null(listObject$`industry_percentile_rank`)) {
        self$`industry_percentile_rank` <- listObject$`industry_percentile_rank`
      }
      else {
        self$`industry_percentile_rank` <- NA 
      }

      if (!is.null(listObject$`overall_percentile_rank`)) {
        self$`overall_percentile_rank` <- listObject$`overall_percentile_rank`
      }
      else {
        self$`overall_percentile_rank` <- NA 
      }

      if (!is.null(listObject$`community_percentile_rank`)) {
        self$`community_percentile_rank` <- listObject$`community_percentile_rank`
      }
      else {
        self$`community_percentile_rank` <- NA 
      }

      if (!is.null(listObject$`employee_percentile_rank`)) {
        self$`employee_percentile_rank` <- listObject$`employee_percentile_rank`
      }
      else {
        self$`employee_percentile_rank` <- NA 
      }

      if (!is.null(listObject$`environment_percentile_rank`)) {
        self$`environment_percentile_rank` <- listObject$`environment_percentile_rank`
      }
      else {
        self$`environment_percentile_rank` <- NA 
      }

      if (!is.null(listObject$`governance_percentile_rank`)) {
        self$`governance_percentile_rank` <- listObject$`governance_percentile_rank`
      }
      else {
        self$`governance_percentile_rank` <- NA 
      }

      if (!is.null(listObject$`human_rights_and_supply_chain_percentile_rank`)) {
        self$`human_rights_and_supply_chain_percentile_rank` <- listObject$`human_rights_and_supply_chain_percentile_rank`
      }
      else {
        self$`human_rights_and_supply_chain_percentile_rank` <- NA 
      }

      if (!is.null(listObject$`community_dev_and_philanthropy_percentile_rank`)) {
        self$`community_dev_and_philanthropy_percentile_rank` <- listObject$`community_dev_and_philanthropy_percentile_rank`
      }
      else {
        self$`community_dev_and_philanthropy_percentile_rank` <- NA 
      }

      if (!is.null(listObject$`product_percentile_rank`)) {
        self$`product_percentile_rank` <- listObject$`product_percentile_rank`
      }
      else {
        self$`product_percentile_rank` <- NA 
      }

      if (!is.null(listObject$`compensation_and_benefits_percentile_rank`)) {
        self$`compensation_and_benefits_percentile_rank` <- listObject$`compensation_and_benefits_percentile_rank`
      }
      else {
        self$`compensation_and_benefits_percentile_rank` <- NA 
      }

      if (!is.null(listObject$`diversity_and_labor_rights_percentile_rank`)) {
        self$`diversity_and_labor_rights_percentile_rank` <- listObject$`diversity_and_labor_rights_percentile_rank`
      }
      else {
        self$`diversity_and_labor_rights_percentile_rank` <- NA 
      }

      if (!is.null(listObject$`training_health_and_safety_percentile_rank`)) {
        self$`training_health_and_safety_percentile_rank` <- listObject$`training_health_and_safety_percentile_rank`
      }
      else {
        self$`training_health_and_safety_percentile_rank` <- NA 
      }

      if (!is.null(listObject$`energy_climate_change_percentile_rank`)) {
        self$`energy_climate_change_percentile_rank` <- listObject$`energy_climate_change_percentile_rank`
      }
      else {
        self$`energy_climate_change_percentile_rank` <- NA 
      }

      if (!is.null(listObject$`environment_policy_and_reporting_percentile_rank`)) {
        self$`environment_policy_and_reporting_percentile_rank` <- listObject$`environment_policy_and_reporting_percentile_rank`
      }
      else {
        self$`environment_policy_and_reporting_percentile_rank` <- NA 
      }

      if (!is.null(listObject$`resource_management_percentile_rank`)) {
        self$`resource_management_percentile_rank` <- listObject$`resource_management_percentile_rank`
      }
      else {
        self$`resource_management_percentile_rank` <- NA 
      }

      if (!is.null(listObject$`board_percentile_rank`)) {
        self$`board_percentile_rank` <- listObject$`board_percentile_rank`
      }
      else {
        self$`board_percentile_rank` <- NA 
      }

      if (!is.null(listObject$`leadership_ethics_percentile_rank`)) {
        self$`leadership_ethics_percentile_rank` <- listObject$`leadership_ethics_percentile_rank`
      }
      else {
        self$`leadership_ethics_percentile_rank` <- NA 
      }

      if (!is.null(listObject$`transparency_reporting_percentile_rank`)) {
        self$`transparency_reporting_percentile_rank` <- listObject$`transparency_reporting_percentile_rank`
      }
      else {
        self$`transparency_reporting_percentile_rank` <- NA 
      }








      self$`company` <- ESGCompanySummary$new()
      self$`company`$setFromList(listObject$`company`)

    },
    getAsList = function() {
      listObject = list()

      listObject[["date"]] <- self$`date`



        
      listObject[["country_average_rating"]] <- self$`country_average_rating`
      listObject[["industry_average_rating"]] <- self$`industry_average_rating`
      listObject[["overall_rating"]] <- self$`overall_rating`
      listObject[["community_rating"]] <- self$`community_rating`
      listObject[["employee_rating"]] <- self$`employee_rating`
      listObject[["environment_rating"]] <- self$`environment_rating`
      listObject[["governance_rating"]] <- self$`governance_rating`
      listObject[["human_rights_and_supply_chain_rating"]] <- self$`human_rights_and_supply_chain_rating`
      listObject[["community_dev_and_philanthropy_rating"]] <- self$`community_dev_and_philanthropy_rating`
      listObject[["product_rating"]] <- self$`product_rating`
      listObject[["compensation_and_benefits_rating"]] <- self$`compensation_and_benefits_rating`
      listObject[["diversity_and_labor_rights_rating"]] <- self$`diversity_and_labor_rights_rating`
      listObject[["training_health_and_safety_rating"]] <- self$`training_health_and_safety_rating`
      listObject[["energy_climate_change_rating"]] <- self$`energy_climate_change_rating`
      listObject[["environment_policy_and_reporting_rating"]] <- self$`environment_policy_and_reporting_rating`
      listObject[["resource_management_rating"]] <- self$`resource_management_rating`
      listObject[["board_rating"]] <- self$`board_rating`
      listObject[["leadership_ethics_rating"]] <- self$`leadership_ethics_rating`
      listObject[["transparency_reporting_rating"]] <- self$`transparency_reporting_rating`
      listObject[["country_percentile_rank"]] <- self$`country_percentile_rank`
      listObject[["industry_percentile_rank"]] <- self$`industry_percentile_rank`
      listObject[["overall_percentile_rank"]] <- self$`overall_percentile_rank`
      listObject[["community_percentile_rank"]] <- self$`community_percentile_rank`
      listObject[["employee_percentile_rank"]] <- self$`employee_percentile_rank`
      listObject[["environment_percentile_rank"]] <- self$`environment_percentile_rank`
      listObject[["governance_percentile_rank"]] <- self$`governance_percentile_rank`
      listObject[["human_rights_and_supply_chain_percentile_rank"]] <- self$`human_rights_and_supply_chain_percentile_rank`
      listObject[["community_dev_and_philanthropy_percentile_rank"]] <- self$`community_dev_and_philanthropy_percentile_rank`
      listObject[["product_percentile_rank"]] <- self$`product_percentile_rank`
      listObject[["compensation_and_benefits_percentile_rank"]] <- self$`compensation_and_benefits_percentile_rank`
      listObject[["diversity_and_labor_rights_percentile_rank"]] <- self$`diversity_and_labor_rights_percentile_rank`
      listObject[["training_health_and_safety_percentile_rank"]] <- self$`training_health_and_safety_percentile_rank`
      listObject[["energy_climate_change_percentile_rank"]] <- self$`energy_climate_change_percentile_rank`
      listObject[["environment_policy_and_reporting_percentile_rank"]] <- self$`environment_policy_and_reporting_percentile_rank`
      listObject[["resource_management_percentile_rank"]] <- self$`resource_management_percentile_rank`
      listObject[["board_percentile_rank"]] <- self$`board_percentile_rank`
      listObject[["leadership_ethics_percentile_rank"]] <- self$`leadership_ethics_percentile_rank`
      listObject[["transparency_reporting_percentile_rank"]] <- self$`transparency_reporting_percentile_rank`




      company_list <- self$`company`$getAsList()
      for (x in names(company_list)) {
        listObject[[paste("company_",x, sep = "")]] <- self$`company`[[x]]
      }
        
      return(listObject)
    }
  )
)
